#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include "dskc31_ioctl.h"

main(int argc, char **argv)
{
	int fd,i;
	char a;
	char buf[80];
	FILE *fp;
	
	if (argc<2) {
		fprintf(stderr,"Use: dskloader <file.hex>\n");
		exit(0);
	}
	
	if ((fp=fopen(argv[1],"r"))==NULL) {perror("fopen"); exit(0); }
	fgets(buf,80,fp);
	if (strstr(buf,"FILE2HEX")!=buf) {
		fprintf(stderr,"Error: Invalid File\n");
		exit(0);
	}

	if ((fd=open("/dev/dskc31",O_WRONLY))==-1) {perror("open"); exit(0);}

	if (ioctl(fd,DSK_IOCTL_RESET)) {	/* DSK RESET */
		fprintf(stderr,"Error: DSK Not ready\n");
		exit(0);
	}
		
	printf("\nLoading %s ...",argv[1]); fflush(stdout);

	fgets(buf,80,fp);	/* Skip Bus Width */
	i=8; write(fd,&i,2);	/* Only 16 bits. C31 Bootloader Error? */

	for(;;){
		fgets(buf,80,fp);
		if(feof(fp)) break;
		sscanf(buf,"%x",&i);
		/* printf("%08x\n",i); */
		write(fd,&i,4);	/* Relies on Little Endian */
	} 

	printf(" OK\n\n");

	fclose(fp);
	close(fd);
}
