
;
;       FIXED ADDRESS DEFINITIONS
;
DMA_ctrl  .set 0x808000;  DMA cntrol
DMA_srce  .set 0x808004;  DMA source address
DMA_dest  .set 0x808006;  DMA destination address
DMA_xfr   .set 0x808008;  DMA Transfer counter
T0_ctrl   .set 0x808020;  TIM0 global control
T0_count  .set 0x808024;  TIM0 count
T0_prd    .set 0x808028;  TIM0 period
T1_ctrl   .set 0x808030;  TIM1 global control
T1_count  .set 0x808034;  TIM1 count
T1_prd    .set 0x808038;  TIM1 period
S0_gctrl  .set 0x808040;  SP 0 global control
S0_xctrl  .set 0x808042;  SP 0 FSX/DX/CLKX port ctl
S0_rctrl  .set 0x808043;  SP 0 FSR/DR/CLKR port ctl
S0_tctrl  .set 0x808044;  SP 0 R/X timer control
S0_tcount .set 0x808045;  SP 0 R/X timer counter
S0_tprd   .set 0x808046;  SP 0 R/X timer period
S0_xdata  .set 0x808048;  SP 0 Data transmit
S0_rdata  .set 0x80804C;  SP 0 Data receive
p_buscon  .set 0x808064;  Primary bus control
RAM0      .set 0x809800;  Internal RAM block 0
RAM1      .set 0x809C00;  Internal RAM block 1
Bint      .set 0x809FC1;  Interrupt Branch Table

        .start "codigo",RAM1
        .sect "codigo"
        .entry ini


;- - - - - - - - - - - - - - - -
PRD0     .set    1000         ; Timer (set for PWM) default rate
PRD1     .set    1001     ;
TSTART   .set    0x000003C3     ; reset and restart value for timers
;- - - - - - - - - - - - - - - -
ini     ldp ini
        ldi 0x38,R0
        sti R0,@p_buscon        ; 1 Wait State on external bus
        maxspeed
        ;=======================  Init T0&T1 for slow PWM modulation
        ldi     PRD0,R0         ; Init periods (note they are different)
        sti     R0,@T0_prd      ;
        ldi     PRD1,R0         ;
        sti     R0,@T1_prd      ;
        ldi     TSTART,R0       ; Start timers (reset and restart)
        sti     R0,@T0_ctrl     ;
        sti     R0,@T1_ctrl     ;

        ldi     @count,R0
del     subi    1,R0
        bnz del

        lopower
        bu $

count   .word 48000000

